{{                                                                           
v1.0b Major changes !!! 2-19-13 !!!
BIG BUFFERS sdbuffer, rambuffer, buffer2 NOW 2k byte for testing

Now display enable will latch displays, and select memgroup! *Uses pre-select
 adapted for SSD1963.

Touch.spin is SINGLETON *I think I have this right, not fully tested!
All SRAM functions are now in seperate object. Perhaps string functions could be moved to seperate object as well? 

'' almost v1.       revision list.
''cleanups and bug fixes
''changes
'' a bunch of opts. Assembly driver almost ready~!  Burst reads to hub seem to work?
'' Now hard-coded for each display. For new SSD 1963 , 7 inch display. *PREP FILE*
''
'' PUB OpenFileRead              - now returns file size
'' PUB SelectSPIGroup            - now releases ALL pins, HI-Z
'' PUB TouchXPercent             = hard coded foe SSD 1289
'' PUB ChangeOrientation         = hard coded foe SSD 1289
'' PUB MergeBackgroundIconRam       - does not need icon file number. auto loads icon to next available file
''
'' Warm-Cold boot now ignores display mode. 
''
''============================================================================================================================================='
'' Additions   -
'' All functions for expander, needs review. I broke them somewhere along the way
'' PreSelectMemGroup            - same as memgroupm, but does not latch to 373. Display Enable does this - for fast draw 
'' PUB FetchSDBuffer            - returns sdbuffer address
'' PUB FileRead(count)          - Reads count bytes to SD buffer
'' PUB FileClose                - Closes the open SD file
'' PUB TextDec(font,value)      - prints decimal value in font
'' PUB RamFree                  - returns the free ram space in words

'' I may have missed some changes. Sorry!
}}


{{
*********************************************************************************************************************************************************
*                                                                                                                                                       *
* ILI9325 OR SSD1289 driver using the Touchblade161 design for faster ram to display transfers                                                          *
* Average Joe and James Moxham 2012                                                                                                                     *
*                                                                                                                                                       *
*********************************************************************************************************************************************************                                                                                                                                *
}} 
CON                                              
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000                             ' 5Mhz crystal
   Margin = 4                                           ' some characters have xoffset of -1 or -2 eg v, and won't display on the extreme left edge
  _1ms      = 1_000_000 /     1_000                     ' Divisor for 1 ms                                                                      

' //////////////////////////////////////////////////////////////////////
{{ VAR '' these are all defined in DAT now
   byte FileNumber                                      ' 0 to 31
   'byte DisplayMode                                    ' type of display 0 = ILI9325, 1= SSD1289, 2 etc  not used, still defined
   byte DisplayLeftRightBoth                            ' "R", "L" or "B"
   word ScreenWidth                                     ' either 240 in portrait or 320 in landscape
   word ScreenHeight                                    ' 320 in portrait or 240 in landscape
   long orientation                                     ' true is portrait
   long curx, cury                                      ' cursor position
   byte FontHeight                                      ' size of the current loaded font (pixels = fontsize *.75)
   word BackFontColor                                   ' the background color in RRRRRGGG GGGBBBBB format
   long StringAddress                                   ' start of string address
   long wcboot                                          ' most recent boot warm = true or cold = false  }}
   
OBJ
    '    exp     :               "fullDuplexSerial4portJM"             ''* 4 port serial driver for expander, only uses 1 port currently
        spi     :               "SPI_ASM"                             ''* thanks to Beau - spi driver for touch screen                                                                                                          *
        fat     :               "SD-MMC_FATEngine.spin"               ''* thanks to Kye  - latest sd driver and no RTC    '' load in cog7?
        pin     :               "TBpins"                              ' Pin configuration
        RAM     :               "TbASM_1963"                               '' try to load pasm into cog 0 or 1!!!
        
''*********************************************************************************************************************************************************            
DAT '' Touch.spin is SINGLETON - DAT type variables allow a single instance of the object to be accessed throughout a complex project
    orientation                 long -1                        ' true is portrait, might be best to set default here?  
    StringAddress               long 0                         ' start of string address
    wcboot                      long 0                         ' most recent boot warm = true or cold = false
    ScreenWidth                 long 0                         ' either 240 in portrait or 320 in landscape *soon 800 or 400
    ScreenHeight                long 0                         ' either 320 in portrait or 240 in landscape *soon 800 or 400

    curx                        word 0                         ' cursor X position
    cury                        word 0                         ' cursor Y position 
    BackFontColor               word 0                         ' the background color in RRRRRGGG GGGBBBBB format

    padd                        word 0                         ' keep things long aligned

    FileNumber                  byte 0                         ' 0 to 31
    DisplayLeftRightBoth        byte 0                         ' "R", "L" or "B"
    FontHeight                  byte 0                         ' size of the current loaded font (pixels = fontsize *.75)
    pad                         byte 0
    
    RamLocation                 long 0[31]                     ' 32 file ram locations
    RamSize                     long 0[31]                     ' File sizes in words - NOT bytes (divide byte by 2)
    sdbuffer                    byte 0[2048]                   ' 1024 byte buffer for sd card interface and also for sending one row 320 x3 = 960 bytes max picture size 
    buffer2                     byte 0[2048]                   ' 512 general purpose hub buffer 
    rambuffer                   word 0[1024]                   ' 512 byte (256 word) buffer easier for using with words, needed to double this.
                                       
    commandbuffer               word 0,0,479,799                     ' FOR FAST DRAW

 ' EXP_Running                 long 0                         ' for expander
'  DisplayMode                 long "S"                         ' type of display 0 = ILI9325, 1= SSD1289, 2 etc  '' hard coded for each display, for now

    
PUB Testing   | deskF, maskF
'' The first PUB is run on boot, so strap all testing here for easy access
'' For testing root-code changes and starting simple programs.
'' If you're writing something of substance, much simpler to make this an object and call BeginProgram *or BeginDesktop*

  BeginDesktop(TRUE) 
  deskf := SDBMPtoRam(String("800.bmp"))    '$223c9
  DrawBMPRam(1,0,0)
  maskF := SDBMPtoRam(string("mask.bmp"))                   ' file 2, load this here - if load after the strings get a white line on the icons
  MergeBackgroundIconRam(String("prop.bmp"),256,256,deskF,maskF)
  DrawBMPRam(deskF,0,0)

  
PUB BeginDesktop(DisplayType)                           ' store the type of display once by the desktop program
'' Start up everything running the desktop
'' DisplayType doesn't matter, hard coded
'  DisplayMode := DisplayType                            ' global variable I = ILI9325, S=SSD1289         not used now
  Begin(true)                                           ' start up everything running the desktop
  result := wcboot

  
PRI BeginProgram                                        ' used by all programs except the desktop program
'' Prepare to run a program
'' Most programs will start with this
  Begin(false)                                          ' any program except the desktop
  result := wcboot

  
PRI Begin(Desktop) |n                                   ' desktop true if run from the desktop program, false for other programs
'' This starts low-level drivers (SD,RAM,DISPLAY)
  RAM.start                                             ' * start cog first *start the external ram / display driver in a cog, needed for many routines so always first
'  DisplayMode := "S"                                   ' using the SSD 1289      
  DisplayBoth                                           ' enable both displays
  wcboot := WarmColdBoot                                ' get the last warm or cold boot value
  'if desktop == true or wcboot == false                 ' If we're starting the desktop or a cold boot
  Start_SSD1963                                       ' Init display
  SetOrientation(true)                                  ' in portrait (true) or landscape mode (false), must be before clearscreen otherwise don't know screensize\\
  if wcboot == false and Desktop == true               ' no need to redisplay every time if worked the first time
    Text(string("SD"))                                    ' string to send, uses internal prop font so can see something if the SD fails to mount   
  fat.fatEngineStart( PIN#_dopin, PIN#_clkpin, PIN#_dipin, PIN#_cspin,{
  }PIN#_wppin, PIN#_cdpin, PIN#_rtcres1, PIN#_rtcres2, PIN#_rtcres3) ' start fat engine 
  fat.mountPartition(0)                                 ' mount the sd card
  if desktop == false                                   ' running a program, this is called without knowing what the ramlocation and ramsize values are
     ManualValues                                       ' coming from outside so reset ramsize and ramlocation values for 0 and 1
  SetCursor(0,0)                                        ' cursor for debugging to 0,0
  if desktop == false                                   ' not the desktop so lets start in Group 3
    SelectSPIGroup                                      ' selects this group and starts the cog


{{Need to examine these when there's time}}

PUB PreSelectMemGroup                                   ' pre select group 1 for display transfer, does not latch group
   spi.stop                                             ' and stop any other cogs here too if needed
   OUTA |= %00000000_00011111_00000000_00000000         ' set /rd /wr /disp wr and 161 clock high
   DIRA |= %00000000_00011111_11111111_11111111         ' enable these pins for output
  ' LatchGroup2                                         ; do this in display select

PUB SelectMemGroup                                      ' select group 1 for memory transfer, latches group
   spi.stop                                             ' and stop any other cogs here too if needed
   OUTA |= %00000000_00011111_00000000_00000000         ' set /rd /wr /disp wr and 161 clock high    
   DIRA |= %00000000_00011111_11111111_11111111         ' enable these pins for output
   RAM.LatchGroup2 
   
PUB SelectSPIGroup                                      ' select group 3 for touch/expander
'' may need to set some pins here as inputs or outputs with a dira

   DIRA &= %00000000_00000000_00000000_00000000         ' so no clashes with the cogs using P0-P2 set these as inputs and P3-P5, and expansion pins
   RAM.LatchGroup3                                          ' select group 2 for spi transfers
   TouchStart                                           ' start the touchscreen cog


'*************** Start string functions ******************************

PUB StringDim(n)                                        ' reserve space for a string array, n= number of strings, 128 max bytes per string
'' reserve space for a string array, n= number of strings, 128 max bytes per string
   Ramsize[Filenumber] := n << 6                        ' * 64 as this is in words, not bytes
   StringAddress := NextLocation                          ' get the location of the string array  
   Filenumber += 1

PUB StringStore(StringN,Source)                               ' store a propeller string("test") to array number Dest 
   bytemove(@rambuffer, Source, (strsize(Source) + 1))     ' move to rambuffer array
   StringToRam(StringN)
   result := stringN                                    ' returns the number passed so can use inside functions as a variable

PUB StringDebug(StringN)                                ' print using the green propeller font - useful if sd card not working so no fonts loaded
   RamToString(StringN)
   Text(@rambuffer)                                     ' print it out

PUB StringClear(StringN)
   bytefill(@rambuffer,0,128)                            ' only really need to do the first one but may help debugging to completely clear the string
   StringToRam(StringN)

PUB StringAddChar(StringN,c) | s                        ' add c to the string
   if c >31 and c <127                                  ' a character that can be displayed
     RamToString(StringN)                               ' get the string
     s := strsize(@rambuffer)
     byte[@rambuffer][s] := c       
     byte[@rambuffer][s + 1] := 0                       ' add in the new zero (can't assume array is cleared)
     StringToRam(StringN)                               ' store back to ram

PUB StringSubChar(StringN)                              ' remove one character from the right same as strings.left(strings.len - 1)   
   RamToString(StringN)
   if strsize(@rambuffer) <> 0                          ' if at least one character
     byte[@rambuffer][strsize(@rambuffer)-1] :=0
   StringToRam(StringN)

PUB StringCopy(Dest,Source)                             ' copy string from source to dest
   RamToString(Source)
   StringToRam(Dest)

PUB StringLeft(Dest,Source,n)                           ' Basic Left$
   RamToString(Source)
   byte[@rambuffer][n] := 0                             ' move the terminator
   StringToRam(Dest)                                    ' move back to ram

PUB StringMid(Dest,Source,start,n) | i                          ' Basic Mid$
   RamToString(Source)
   repeat i from 0 to n-1
     byte[@rambuffer][i] := byte[@rambuffer][i+start-1]       ' possibly could use bytemove here
   byte[@rambuffer][n] := 0                                'add in the new zero terminator  
   StringToRam(Dest)

PUB StringMidEnd(Dest,Source,start) | i ' same as above but no n, just runs to the end of the string
   RamToString(Source)
   i := 0
   repeat 
     byte[@rambuffer][i] := byte[@rambuffer][i+start-1]       ' possibly could use bytemove here
     i+=1
   until byte[@rambuffer][i-1] == 0                     ' until zero terminator
   StringToRam(Dest)

PUB StringRight(Dest,Source,n) | i,m
   RamToString(Source)
   m := strsize(@rambuffer) - n 
   repeat i from 0 to n                                 ' Basic Right$. include the terminator
     byte[@rambuffer][i] := byte[@rambuffer][i+m]
   StringToRam(Dest)

PUB StringInstr(Source,Start,c) | i                              ' find c in the string starting at start
    RamToString(Source)
    result := 0                                              ' return 0 if not found
    repeat i from (start-1) to strsize(@rambuffer)
      if byte[@rambuffer][i] == c
        result := i+1                                   ' 1 is first character
        quit   
     
PUB StringBin(Dest,n)                                   ' convert n to a binary value at Dest. Prefix 0b
    repeat result from 33 to 2
      byte[@rambuffer][result] := ((n & 1) + "0")
      n >>= 1
    byte[@rambuffer][34] := 0                           ' add zero terminator
    byte[@rambuffer][0] := "0"                          ' prefix 0b same as some versions of C
    byte[@rambuffer][1] := "b"                          
    StringToRam(Dest)                                   ' store

PUB StringHex(Dest,n)                                   ' number to hex, always 8 characters
  repeat result from 9 to 2
    byte[@rambuffer][result] := lookupz((n & $F): "0".."9", "A".."F")
    n >>= 4
  byte[@rambuffer][10] := 0                              ' zero at end
  byte[@rambuffer][0] := "0"                          ' prefix 0x same as C
  byte[@rambuffer][1] := "x"   
  StringToRam(Dest)

PUB StringDec(Dest,n) | sign                                   ' number to decimal string, always 11 characters
  sign := "+"
  if(n < 0)
    sign := "-"
  if(n == negx)
    bytemove(@rambuffer, string("-2147483648"), 11)           ' max negative number special case
  else
    repeat result from 10 to 1
      byte[@rambuffer][result] := ((||(n // 10)) + "0")
      n /= 10
  byte[@rambuffer][0] := sign                           ' sign at the front
  byte[@rambuffer][11] := 0                             ' zero terminator
  StringToRam(Dest)

PUB StringStr(Dest,n) | found                                    ' same as Basic STR - similar to Dec above but sign is either space or negative, and leading zeros removed  
   StringDec(Dest,n)                                    ' number preserved in rambuffer
   found := 10                                          ' if answer was zero don't remove leading zero
   repeat result from 1 to 10
     if byte[@rambuffer][result] <> "0"
       found := result
       quit
   repeat result from 1 to 11
     byte[@rambuffer][result] := byte[@rambuffer][result +found -1]             ' shuffle over if needed    
   if byte[@rambuffer][0] == "+"
     byte[@rambuffer][0] := " "                         ' Basic syntax, - or blank
   StringToRam(Dest)                                    ' resend to external ram

PUB StringVal(Source) | sign,i,k                        ' returns value of the string, hex 0x, binary 0b, decimal + or - or space or no leading character just a number
  RamToString(Source)
  if byte[@rambuffer][1] == "x"                         ' this is a hex number
    repeat k from 2 to strsize(@rambuffer) -1           ' leading two characters always 0x
      result := ((result <- 4) + (byte[@rambuffer][k] & $F))  
    return

  if byte[@rambuffer][1] == "b"                         ' this is a binary number
     repeat k from 2 to strsize(@rambuffer) -1           ' leading two characters always 0b 
       result := ((result << 1) + (byte[@rambuffer][k] & 1))  
     return

  ' else if got here this must be a decimal number. It could start with a number(no leading sign), or a space, or a + or a -
  sign := byte[@rambuffer][0]
  i := 0                                                ' start location
  if sign == "+" or sign == "-" or sign == " "           ' this is a decimal number ** must start with a space or a +  or a -**
    i := 1                                               ' leading character so start here
  repeat k from i to (strsize(@rambuffer)-1)              ' if ever use right to left, don't use step -1, spin puts it in if start is less than finish and if there is a step -1 it is one less loop
    result := ((result *10) + byte[@rambuffer][k] & $F)   'very clever, the & $F works because zero is hex0x30, the pre multiply shifts previous numbers to the left so can do left to right. Easier to understand with Kye's binary converter with the left shift
  if sign == "-"
    result *= -1                                       ' if negative then negate

PUB StringJoin(Dest,Source1,Source2)                    ' Dest$= Source1$+Source2$
   RamToString(Source2)
   bytemove(@buffer2,@rambuffer,128)                    ' store string2 to buffer2
   RamToString(Source1)                                 ' get first string
   bytemove(@rambuffer+strsize(@rambuffer),@buffer2,strsize(@buffer2)+1)          ' thanks to Kye for this one
   StringToRam(Dest)                                    ' store back to ram

PUB StringUcase(Dest,Source)
   RamToString(Source)
   repeat result from 0 to strsize(@rambuffer)
     if ((byte[@rambuffer][result] => "a") and (byte[@rambuffer][result] =< "z"))
       byte[@rambuffer][result] -= 32
   StringToRam(Dest)

PUB StringLcase(Dest,Source)
   RamToString(Source)
   repeat result from 0 to strsize(@rambuffer)
     if ((byte[@rambuffer][result] => "A") and (byte[@rambuffer][result] =< "Z"))
       byte[@rambuffer][result] += 32
   StringToRam(Dest)

PUB StringTrim(Dest,Source)
   RamToString(Source)
   if byte[@rambuffer][0] == "+" or  byte[@rambuffer][0] == " " or byte[@rambuffer][0] == "-"         
     repeat result from 0 to strsize(@rambuffer)
       byte[@rambuffer][result] := byte[@rambuffer][result+1]      ' delete the first +,- or space
   StringToRam(Dest)

PUB StringSaveFile(Filen,Start,Finish) | i,j ' filen might be string array 0, start could be 1, finish could be 4        
   RamToString(Filen)                                 ' fetch the filename
   fat.newfile(@rambuffer)        ' create the file, if not working use \fat.  for debugging, see PUB openfileread for an example
   result := \fat.openfile(@rambuffer,"W")                        ' open for writing return error if there is one
   repeat i from Start to Finish
     RamToString(i)
     j := strsize(@rambuffer)
     byte[@rambuffer][j] := 13                          ' carriage return
     byte[@rambuffer][j+1] :=10                         ' line feed
     byte[@rambuffer][j+2] := 0                          ' end of new line
      fat.writedata(@rambuffer,j+2)                      ' write this line
   FileClose                                            ' close the file

PUB StringLoadFile(Filen,Stringnumber)| s,r,c,t,z ' read filename, new line every crlf. Must have enough space reserved in the string array
    RamToString(Filen)                                                                                              ' copy a file from the SD card to the ram disk
    OpenFileRead(@rambuffer)
    s := 0                                              ' sd counter
    r := 0                                              ' rambuffer counter
    t := 0                                              ' total number of bytes
    z := fat.filesize                                   ' size of the file
    repeat (z >> 9) +1                                  ' include any remainder as +1, do blocks of 512 bytes each as natural size of SD blocks
      fat.readdata(@sdbuffer,512)                       ' read from SD card
      repeat s from 0 to 511
        c := byte[@sdbuffer][s]                         ' get the next byte
        if t =< z                                       ' might read in one more 512 byte block to ensure gets any remainder
          if c == 13 or r > 126                         ' end of a line so new string, or string too long
            byte[@rambuffer][r] := 0                    ' end of string terminator
            StringToRam(Stringnumber)
            stringnumber +=1                            ' new string number
            r := 0                                      ' start at beginning of rambuffer
          if c >31 and c < 127
            byte[@rambuffer][r] := c                    ' store if a valid character
            r +=1
        t +=1                                           ' number of bytes read
    FileClose                                       ' close the file

PUB StringLen(Source)                                   ' string length
   RamToString(Source)
   result := strsize(@rambuffer)

PUB StringPrint(Font,Source) | i,s                      ' print this string using using font in memory and curx and cury
  RamToString(Source)
  s := strsize(@rambuffer)
  repeat i from 0 to (s-1)
    curx := TextChar(Font,byte[@rambuffer][i],curx,cury)

PUB StringRamBuffer(Source)                             ' string to rambuffer array
   RamToString(Source)
   result := @rambuffer                                 ' return pointer to the rambuffer array

PUB StringCompare(Source1,Source2) | characters,Othercharacters
   RamToString(Source2)
   bytemove(@buffer2,@rambuffer,128)                    ' store string2 to buffer2
   RamToString(Source1)
   ' copied from Kye's string driver
'' ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'' // Compares two strings case sensitively.
'' //
'' // Returns zero if the two strings are equal.
'' // Returns a positive value if "characters" comes lexicographically after "otherCharacters".
'' // Returns a negative value if "characters" comes lexicographically before "otherCharacters".
'' //
'' // Characters - A pointer to a string of characters.
'' // OtherCharacters - A pointer to another string of characters.
'' ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    characters := @rambuffer
    otherCharacters := @buffer2
    repeat
      result := (byte[characters] - byte[otherCharacters++])
    while(byte[characters++] and (not(result)))


   'result := true
   'repeat i from 0 to strsize(@rambuffer)
   '  if byte[@buffer2][i] <> byte[@rambuffer][i]
   '    result := false
   '    return    

PRI StringToRam(StringN)
   HubToRam(StringN << 6 + StringAddress,64)                        ' 64 words =128 bytes, so work in groups of 64 words

PRI RamToString(StringN)    
   RamToHub(StringN << 6 + StringAddress,64)                          ' moves to rambuffer array    

' ***************** end string routines *************************

' ***************** Start array routines *************************

PUB ArrayDim(n)                                         ' n = number of longs, reserve space for a long array
   Ramsize[Filenumber] := n << 1                        ' reserve this space  - number of words x2
   NextLocation                                         ' increment the location counter
   result := FileNumber                                 ' return the filenumber to the calling program
   Filenumber += 1                                      ' increment the file number

PUB ArrayWrite(f,e,n)                                    ' f = filenumber, e=element, n=number
    long[@rambuffer][0] := n
    HubToRam(ramlocation[f]+(e<<1),2)                   ' store to ram, two words

PUB ArrayRead(f,e)                                      ' read array element e from f filenumber
    RamToHub(ramlocation[f]+(e<<1),2)                   ' read the long
    result := long[@rambuffer][0]                       ' get the long back  

'************* end array functions ********************




' ***************** Start RAM routines *************************

PUB RamFree | t, n
'' returns the free RAM space in words. *2 for bytes
  t := 0
  repeat n from 0 to 30
    t += RamSize[n]
  result := $7FFFF - t

PUB RamErase(n)
    Filenumber := n                                     ' erase lookup table for the ram files, effectively erases the files    
                                                        ' if 0 then erase all, if 1 then leave the desktop intact (assuming this was loaded first)
PUB ClearRam
    Filenumber := 2                                     ' clear ram but leave file 0 = warm or cold boot and 1 = background picture

' ***************** end RAM routines *************************



' ***************** Start display routines *************************

PUB DisplayBoth
    DisplayLeftRightBoth := "B"                         ' don't enable here, do this just before sending data


PUB DisplayLeft                                         ' send all data to the left display
    DisplayLeftRightBoth := "L"                         ' don't enable here, do this just before sending data


PUB DisplayRight
    DisplayLeftRightBoth := "R"


PUB GetCurX
    result := curx                                       ' get the text cursor position


PUB GetCurY
    result := cury


PUB SetCurx(n)                                            ' set the text cursor position
    Curx := n


PUB SetCury(n)
    Cury := n
    

PUB SetCursor(x,y)               
    curx := x
    cury := y


PUB GetBackFontColor
   result := BackFontColor


PUB GetRamLocation(n)
   result := Ramlocation[n]


PUB GetFilenumber
   result := filenumber

PUB SetFilenumber(n)                                     ' reset the file number
    Filenumber := n


PUB NextLocation                                         ' get the next free location in ram based on last files size
    if FileNumber == 0
       RamLocation[0] := 0                              ' work out start of this file based on last file size
    else   
       RamLocation[FileNumber] := RamLocation[FileNumber - 1] + RamSize[FileNumber - 1]  ' get location in ram
    result := RamLocation[FileNumber]   



PUB GetMargin
  result := Margin



PUB FetchSDBuffer
    result :=@sdbuffer
    

PUB FetchRamBuffer
    result := @rambuffer    


PUB HubToRam(RamAddress,Number)                         ' send pixels from rambuffer hub to ram
   SpinHubToRam(@rambuffer,RamAddress,Number)    ' spin version

PUB RamToHub(RamAddress,Number)                         ' send pixels from ram to hub at rambuffer
   SpinRamToHub(@rambuffer,Ramaddress, number)

PUB RamToDisplay(RamAddress,Number)                     ' send pixels from ram to display
   SpinRamToDisplay(Ramaddress, Number)
   


PUB RamWordsCopy(Destination,Source,Number)                 ' copy words from one ram area to another. (max number is size of rambuffer)
    SpinRamToHub(@rambuffer,Source,Number)
    SpinHubToRam(@rambuffer,Destination,Number)

    
PUB ReadRamLong(WordStart,Bytevalue)                   ' easier calculating
    SpinRamToHub(@result,Wordstart+Bytevalue>>1,2)
    return result
    

PUB Chain(stringptr)
    result := \fat.bootpartition(stringptr) ' reboot and run this program
    

PUB SDtoRam(stringptr) | RamAddress,remainder,sizebytes,sizewords                              ' copy a file from the SD card to the ram disk
    OpenFileRead(stringptr)
    sizebytes := fat.filesize                           ' size in bytes
    sizewords := sizebytes >>1                          ' size in words
    ramaddress := NextLocation                          ' next free place in ram
    RamSize[FileNumber] := sizewords                    ' ram disk works in words, not bytes
    repeat sizebytes >> 9                               ' do blocks of 512 bytes each as natural size of SD blocks
      fat.readdata(@sdbuffer,512)                       ' read from SD card
      SpinHubToRam(@sdbuffer,RamAddress,512)            ' move to ram
      RamAddress += 256                                 ' increment ram address by 256 (half 512 as using words)
    remainder :=  sizebytes & %00000000_00000000_00000001_11111111 ' remainder (if not a multiple of 512) 
    if remainder <> 0
      fat.readdata(@sdbuffer,remainder)
      SpinHubToRam(@sdbuffer,RamAddress,remainder)             ' send out the remainder bytes
    FileClose                                       ' close the file
    result := FileNumber                                ' return this file
    FileNumber +=1                                      ' point to next location

PUB SDBMPtoRam(stringptr) | width,height,w,i,ramaddress       ' .bmp from sd to ram and convert to 2 byte ili format and reverse order along the way
' http://en.wikipedia.org/wiki/BMP_file_format scroll down about 1/3 of the way for the header formats
' get the width, height
' store these as 2 longs at the beginning of the ram file
' the bitmap format starts at the last row and works up so need to reverse the order
    ramaddress := NextLocation                          ' get the next ram location
    OpenFileRead(stringptr)
    fat.readdata(@sdbuffer,$36)                         ' get the header 0x36 hex bytes
    width  := sdbuffer[$12] + sdbuffer[$13] << 8         ' only read in two bytes as never will be >64k wide or high
    height := sdbuffer[$16] + sdbuffer[$17] << 8 
    w := width * 3                                      ' this number of bytes per row, and round up to nearest 4 bytes et 327 goes to 328 The size of each row is rounded up to a multiple of 4 bytes (a 32-bit DWORD) by padding.
    w +=3                                               ' add 3 and
    w &= %11111111_11111111_11111111_11111100           ' round down
    SpinHubToRam(@sdbuffer,ramaddress,$36)              ' store header to ram
    i := $36 + ramaddress + ((height - 1) * width)      ' start + header and on the last row and work back
    repeat height 
      fat.readdata(@sdbuffer,w)                         ' read in the first row
'      RAM.CogCmd("N",@sdbuffer,i,width)
      RAM.CogCmd("F",@sdbuffer,@rambuffer,width)
      HubToRam(i,width)                                 ' send to ram     
      i -= width                                        ' subtract the width, move up the picture
    FileClose
    Ramsize[Filenumber] := $36 + (width * height)       ' size of bitmap file in words
    result := FileNumber                                ' returns the current file number
    FileNumber += 1                                     ' add 1 to filenumber       


PUB DrawBMPRam(f,x,y) | rampointer,width,height        ' pass the filenumber and the x and y location, searches for this file and if found, displays it
   rampointer := RamLocation[f]                        ' find the start of the file
   SpinRamToHub(@sdbuffer,rampointer,$36)              ' read in the header
   width := sdbuffer[$12] + sdbuffer[$13] << 8         ' only read in two bytes as never will be >64k wide or high
   height := sdbuffer[$16] + sdbuffer[$17] << 8                               
   Draw(x,y,x+width-1,y+height-1)                       ' set up the area to draw
   RamToDisplay(RamPointer + $36,width*height)          ' skip the header and display
   result := (width <<16) | (height & $0000FFFF)        ' return the width and height combined into a long

' ***************** end ram disk routines

PUB MergeBackgroundIconRam(stringptr,x,y,desktop,mask) | i,j,k,icon  ' merge icon and background - if mask =0 then background, else icon (not classic alpha compositing but close enough)
'' Merge icon with desktop background
'' icon is now set automatically
'' stringptr is pointer to name of icon to load.
'' X is the starting X location for merge
'' Y is the starting Y location for merge
'' desktop is file number of desktop
'' mask is file number of mask
    icon := SDBMPtoRam(stringptr)                       ' load icon into ram
    Filenumber -= 1                                     ' reset filenumber
    i := RamLocation[desktop] + $36 + (y*(screenwidth+1)+x)   ' location of picture pixel in ram
    j := RamLocation[icon] + $36                        ' location of icon in pixel in ram
    k := RamLocation[mask] + $36                        ' location of mask pixel in ram
    repeat 60
      SpinRamToHub(@sdbuffer,i,59)                      ' get 59 pixels from background
      SpinRamToHub(@rambuffer,j,59)                     ' get 59 icon pixels
      SpinRamToHub(@buffer2,k,59)                       ' get words for the mask
      RAM.CogCmd("X",@sdbuffer,@rambuffer,@buffer2)     ' pasm version of the above 3 lines
      SpinHubToRam(@sdbuffer,i,59)                      ' send back modified line to the picture buffer
      i += screenwidth+1                                ' next line in picture
      j +=59                                            ' icon next line
      k +=59                                            ' next line in mask (bytes) - buffer2

''FAT Functions

PUB GetFileSize
  result := fat.fileSize
  
PUB FileRead(count)      ' copy file to sdbuffer, starts from current file position
    fat.readdata(@sdbuffer,count)
     
PUB FileClose
    fat.closefile                                       ' close the file
           
PUB OpenFileRead(stringptr) ' open a file for reading and display a message if it fails
   result := \fat.openfile(stringptr,"R")
   if fat.partitionerror <> 0                           ' failed to find the file
     Text(stringptr)                         ' print the filename
     Text(result)                            ' print the error message
     repeat                                             ' stop the program
   else
     result := fat.filesize


'' Touch functions

PUB TouchXPercent
    result := TouchValue & 255                          ' decode xval 0-100%
    'if DisplayMode == "S"
      result := 100-result                              ' SSD1289 x runs the other way

PUB TouchYPercent
    result := TouchValue >> 8                           ' decode yval 0-100%  

PUB TouchSwishX | xval,oldxval,difference,average ' returns result = +ve or -ve depending on swish direction     ' did finger move left or right?
      SelectSPIGroup ' turn on the spi touchscreen
      oldxval := 255' for startup
      average := 0
      repeat until (average > 30) or (average < -30)
        ' possibly add a decay function here for average
        pause1ms(50)
        xval := TouchXPercent                        ' decode xval 0-100%
        if xval == 255                                  ' not touched
          oldxval := 255                                ' reset oldxval as well
        else
          if oldxval <>255                                ' discard the first reading as the screen is touched
            difference := xval - oldxval
            'printdecimal(xval)
            'printdecimal(difference)
            average := average + difference             ' 
            'printdecimal(average)
            'crlf
          oldxval := xval                                 ' store for next time
      result := average                                 ' return negative or positive value

PUB TouchSwishY | yval,oldyval,difference,average ' returns result = +ve or -ve depending on swish direction     ' did finger move left or right?
      SelectSPIGroup ' turn on the spi touchscreen
      oldyval := 255' for startup
      average := 0
      repeat until (average > 30) or (average < -30)
        ' possibly add a decay function here for average
        pause1ms(50)
        yval := TouchYPercent                        ' decode xval 0-100%
        if yval == 255                                  ' not touched
          oldyval := 255                                ' reset oldyval as well
        else
          if oldyval <>255                                ' discard the first reading as the screen is touched
            difference := yval - oldyval
            average := average + difference             ' 
          oldyval := yval                                 ' store for next time
      result := average                                 ' return negative or positive value             


PUB TouchStart
      SPI.start(3,0)                                        ' delay,state, start clock high
                                                        '      
                                                          '            12    D
PRI TouchX                                                 '  S A0-A2  mode  S/D   PD1-PD '' should be compatible!!
      SPI.SHIFTOUT(PIN#Touch_DataIn, PIN#Touch_Clock, 5, 8 , %1__101____0_____0____00) ' reads x from 500 to 3700 (off < 500 )
      result := SPI.SHIFTIN(PIN#Touch_DataOut,PIN#Touch_Clock,2, 12)


PRI TouchY      
      SPI.SHIFTOUT(PIN#Touch_DataIn, PIN#Touch_Clock, 5, 8 , %1001_0000) ' reads y from 400 to 3800 (off > 3800 )
      result := SPI.SHIFTIN(PIN#Touch_DataOut,PIN#Touch_Clock,2, 12)


PRI TouchValue | xval,yval,x,y ' returns % values 0-100% (or 255 for no touch)
      xval := TouchX
      yval := TouchY
      if (xval => 500) and (yval =< 3800)                       ' both have to be valid for a touch
        pause1ms(2)                               ' tiny delay then read again as the first reads may not have the correct value
        xval := TouchX
        yval := TouchY
        if (xval => 500) and (yval =< 3800)                 ' and if valid again, now more likely this value is correct
            x := xval - 440                                    ' scale 0-3360
            x /=  32                                     ' scale 0-100
            x <#= 100                                    ' max 100
            x #>=0                                       ' min 0
            x := 100 - x                                 ' so left edge on left
            y := yval -420                               ' scale 0-3180
            y /= 32                                      ' scale 0-100
            y <#= 100                                    ' max 100
            y #>=0                                       ' min 0
            y := 100-y                                   ' so 0 is top left     
            result := (y <<8) | x                       ' return 00000000_00000000_YYYYYYYY_XXXXXXXX   
      if (xval < 500) or (xval >3800)
        result := $0000FFFF                             ' invalid number(s)



'' RAMfont.
     
PUB crlf
    cr
    lf

PUB cr                                                  ' carriage return, to left margin
    curx := Margin                                      ' some characters are -1 xoffset so won't display

PUB lf                                                  ' line feed, move up one
    cury += FontHeight
    if cury + FontHeight > screenheight                 ' did we print the last line?
      ClearRectangle(0,0,screenwidth,screenheight,BackFontColor) 
      cury := 0                                         ' if off the bottom of the screen then clear screen start at the top (VT00 does scrolling)
    'ClearFontBackground(0,cury,screenwidth,cury + FontHeight) ' clear background line to the background color ready to draw


PUB TextDec(font,value) | i, x                    ''From PST
{{Print value as decimal characters. using font file from ram
  Parameter:
    value - byte, word, or long value to send as decimal characters.}}

  x := value == NEGX                                                            'Check for max negative
  if value < 0
    value := ||(value+x)                                                        'If negative, make positive; adjust for max negative
    curx := TextChar(font,("-"),Curx,Cury)                                                                   'and output sign

  i := 1_000_000_000                                                            'Initialize divisor

  repeat 10                                                                     'Loop for 10 digits
    if value => i                                                               
      curx := TextChar(font,value / i + "0" + x*(i == 1),Curx,Cury)                                        'If non-zero digit, output digit; adjust for max negative
      value //= i                                                               'and digit from value
      result~~                                                                  'flag non-zero found
    elseif result or i == 1
      curx := TextChar(font,"0",Curx,Cury)                                                                 'If zero digit (or only digit) output it
    i /= 10                                                                     'Update divisor
    

PUB TextT(FileN,stringptr)                 'print at curx,cury using file number in ramdisk
'' Print a zero-terminated string
  repeat strsize(stringptr)
    curx := TextChar(FileN,byte[stringptr++],curx,cury)

PUB TextChar(FileN,ascii,x,y) | jump,size,width,height,ramaddress,xoffset,yoffset,xadvance   ' read out a character from a .ifn file stored in ram
  ' pass Fonttable = global
  ' moves to next line if off the end
    ramaddress := RamLocation[FileN]
    jump := ReadRamLong(ramaddress,(ascii << 2) + 256)   ' jump location = ascii *4 plus fonttable + 256
    SpinRamToHub(@buffer2,ramaddress+jump>>1,20)                ' read in the width height as a block = quicker than readramlong
    size := long[@buffer2][0]                           ' size in pixels of this character
    xadvance := long[@buffer2][5]                       ' amount to move to next character   
    'if size > 0 and ascii <> 32                         ' no need to print anything if size is zero or read more font data
    width := long[@buffer2][1]                        ' width
    height := long[@buffer2][2]                       ' height
    xoffset := long[@buffer2][3]                      ' xoffset to move
    yoffset := long[@buffer2][4]                      ' yoffset to move
    if (x+width -1 + xoffset) > screenwidth 
        crlf                                            ' do a new line if it won't fit
        x := curx
        y := cury
    if ascii < 32
      xadvance := 0                                     ' add nothing if a non displaying character
    if ascii == 13                                  ' carriage return
        cr
        x := curx
        return
    if ascii ==10                                   ' line feed (new line)
        lf
        y := cury
        return
    if 32 < ascii  < 127 ' space not displayed
      Draw(x+xoffset,y+yoffset,x+width-1+xoffset,y+height-1+yoffset)      ' draw on screen
      RamToDisplay(ramaddress+((jump+32)>>1),size)       ' move bytes from ram out to the display
    return x + xadvance

PUB LoadFont(stringptr) | filesize,i                ' read a .ifn file premade in angelcode bmfont and then the vb.net program
    SDtoRam(stringptr)                                  ' font to ram disk, adds one to filenumber
    SpinRamToHub(@rambuffer,RamLocation[Filenumber-1],128) ' read first 128 words =256 bytes back
    FontHeight := byte[@rambuffer][251]                 ' font height
    repeat i from 0 to 2
      sdbuffer[i] := byte[@rambuffer][35+i]
    RAM.CogCmd("E",@sdbuffer,@buffer2,1)                         ' convert to 2 byte .ili format
    BackFontColor := ( byte[@buffer2][1] << 8) | byte[@buffer2][0] ' correct order
    result := FileNumber-1                              ' return pointer to the font file in ram

PUB Clearscreen(color) | tmp                                  ' uses 2 byte ILI color (see below for rgb conversion)
    wordfill(@rambuffer,color,256)
    Draw(0,0,screenwidth,screenheight)                           ' set up the area of the screen to draw in   
    tmp := ((screenwidth * screenheight) / 256) + 1
    repeat tmp
      SpinHubToDisplay(@rambuffer,256)

PUB RGBtoWord(R,G,B)                                     ' convert RGB to 2 byte ILI color 
    sdbuffer[0] := R
    sdbuffer[1] := G
    sdbuffer[2] := B                        
    RAM.CogCmd("E",@sdbuffer,@buffer2,1)
    result := ( byte[@buffer2][1] << 8) | byte[@buffer2][0] ' correct order 
    
PUB ClearRectangle(x1,y1,x2,y2,ColorWord) | i,size,remainder ' clears an area of the screen to the current font background color
    size := (x2-x1+1) * (y2 - y1 +1)                    ' number of pixels
    remainder := size & 255                             ' if not a whole number of 256 pixels
    repeat i from 0 to 255                              ' move the background font colour to the buffer
      rambuffer[i] := ColorWord
    Draw(x1,y1,x2,y2)                                   ' set up the area of the screen to draw in
    repeat size >> 8                                    ' 256 pixel blocks
      SpinHubToDisplay(@rambuffer,256)                    
    if remainder <> 0  
      SpinHubToDisplay(@rambuffer,remainder)                     ' do the remainder

PUB Drawline(x1,y1,x2,y2,ColorWord)                     ' draws a vertical or horizontal line
   ClearRectangle(x1,y1,x2,y2,ColorWord)                ' same as drawing a rectangle 
      
PUB SetOrientation(e) ' change orientation true = portrait. Changes global variable 'orientation' and also screen width and height
   orientation := e
   ChangeOrientation(orientation)
   if orientation
     screenwidth :=479
     screenheight :=799
   else
     screenwidth :=799
     screenheight :=479

PUB ChangeOrientation(n) ' pass true = portrait or false = landscape, changes global variable orientation in this object
    DisplayEnable                                                               ' enable the display(s)
    orientation := n

    if orientation
      Lcd_Write_Com ($0036)                              ' //rotation
      Lcd_Write_Data($0021)                              ' 3 is 180
    else
      Lcd_Write_Com ($0036)                              ' //rotation
      Lcd_Write_Data($0000)                              ' 3 is 180

'' Debugging font

PUB hex(value, digits)   ' uses internal prop font and slow pixel drawing (for very basic debugging without an SD font)
''    DisplayEnable     draw does this                                                          ' enable the display(s)                                                                           
'' Print a hexadecimal number
  propfont_out("O")
  propfont_out("x")
  value <<= (8 - digits) << 2
  repeat digits
    propfont_out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))
  PropFontcrlf

PUB Text(stringptr)                          'print at curx,cury
  repeat strsize(stringptr)
    Propfont_out(byte[stringptr++])
  PropFontcrlf

PUB PropFontcrlf
    curx := 0
    cury += 32                                          ' new line at end of string
    if cury > screenHeight                              ' bottom of screen so new screen
      curx:=0
      cury:=0

PUB Propfont_out(ascii) | address,pixels
    Draw(curx,cury,curx+15,cury+31)                     ' location to start drawing 
    address := $8000 + (ascii >> 1) << 7                ' get rom address
    repeat 32                                           ' 32 rows per character, split in two parts
      pixels := long[address]                           ' get rom font data
      pixels := pixels >> (ascii & 1)                   ' shift for odd characters
      repeat 16 ' 16 columns
        if pixels & 1
          Pixel(%00000111_11100000)                     ' foreground color RRRRRGGG_GGGBBBBB
        else
          Pixel(%00000000_00000000)                     ' background color 
        pixels := pixels >> 2                           ' alternate pixels interleaved so shift 2
      address += 4 
    curx +=16
    
    if curx  > screenWidth                              ' new line
      Propfontcrlf

PUB Draw(x1, y1, x2, y2)                                ' sets the pixel to x1,y1 and then fills the next (x2-x1)*(y2-y1) pixels
   if orientation                                   ' landscape mode so swap x and y
       result :=x1                                       ' swap x1 and y1
       x1 := y1
       y1 := result
       result := x2                                      ' swap x2 and y2
       x2 :=y2
       y2 := result
   DisplayEnable                                    ' enable one or both displays
    Lcd_Write_Com($002A)
    Lcd_Write_Data(x1>>8)
    Lcd_Write_Data(x1&$ff)
    Lcd_Write_Data(x2>>8)
    Lcd_Write_Data(x2&$ff)
    
    Lcd_Write_Com($002B)
    Lcd_Write_Data(y1>>8)
    Lcd_Write_Data(y1&$ff)
    Lcd_Write_Data(y2>>8)
    Lcd_Write_Data(y2&$ff)
    
    Lcd_Write_Com($002c)
   LCD_RS_High
{  

  DrawFast(x1, y1, x2, y2)

PUB DrawFastSetup                                    ' setup for a group of fast draw commands
    DisplayEnable                                    ' enable one or both displays

PUB DrawFast(x1,y1,x2,y2) ' faster version, assumes displayenable and selectmemgroup and orientation already done

    DisplayEnable

'    if not orientation
      commandbuffer[0] := x1
      commandbuffer[1] := y1
      commandbuffer[2] := x2
      commandbuffer[3] := y2
     else                       ' swap x1,y1 and swap x2,y2
      commandbuffer[0] := y1
      commandbuffer[1] := x1
      commandbuffer[2] := y2
      commandbuffer[3] := x2

 RAM.cogcmd("G",@commandbuffer,0,0)             ' SSD1289
}
PUB Pixel(pixelcolor)               ' send out a pixel
     '' it is more efficent to send one Draw command then lots of pixels than sending individual pixels
     '' but of course, you can send draw x,y,x,y where x and y are the same and then send one pixel
Lcd_Write_Fast_Data(pixelcolor)   ' need to set RS high at beginning of this group (ie call Draw first)

PUB pause1ms(period) | clkcycles
'' Pause execution for period (in units of 1 ms).
  clkcycles := ((clkfreq / _1ms * period) - 4296) #> 381     ' Calculate 1 ms time unit
  waitcnt(clkcycles + cnt)                                   ' Wait for designated time

PUB SetWarmBoot
    long[@rambuffer][5] := $5761726D                    ' spell Warm in hex, start at 5 as zero gets corrupted
'    byte[@rambuffer][10] := "S"                         ' store the current display mode
    HubToRam(0,20)                                      ' send words to external ram (ramdiskstart is zero)
    ClearScreen(0)                                      ' so user sees something happen as there is a bit of a delay rebooting
    reboot

PUB WarmColdBoot ' store warm or cold boot  - reserve first 20 bytes in sram for interfacing with programs
    ' Ramdisk file 0 is the boot string Warm or Cold
    ' ramdisk file 1 is the background
    Ramtohub(0,20)         ' read words from the ram 
    if long[@rambuffer][5] == $5761726D
      result := true
    else
      result := false
    long[@rambuffer][5] := $FFFFFFFF                    ' erase previous warm/cold boot
'    byte[@rambuffer][10] := DisplayMode                 ' store display mode
    HubToRam(0,20)                            ' send words to external ram (ramdiskstart is zero)
    RamSize[0] := 20                          ' reserve 20 bytes
    RamLocation[0] := 0
    Filenumber := 1

PUB ManualValues
     RamLocation[0] := 0
     RamSize[0] := $14                                   ' put in values manually - 20 bytes for warm boot
     RamLocation[1] := $14
     RamSize[1] := $5DC36 '$12C36                                ' 76800 for the desktop picture
     FileNumber := 2                                     ' running a program not a desktop

PRI DisplayEnable ' pass DisplayRightLeftBoth
   PreSelectMemGroup
   case DisplayLeftRightBoth
     "R":RAM.Latch_DisplayR
     "L":RAM.Latch_DisplayL
     "B":RAM.Latch_DisplayB
     

PRI SpinHubToRam(hubaddress, ramaddress, number)        ' move data from hub to ram
   RAM.CogCmd("S",hubaddress,ramaddress,number)             ' pasm block move

PRI SpinRamToHub(hubaddress,ramaddress,number)          ' move data from ram to hub
   RAM.CogCmd("T",hubaddress,ramaddress,number)             ' pasm block move   

PRI SpinRamToDisplay(ramaddress,number)                 ' ramaddress, number of words (pixels)
   RAM.CogCmd("U",0,ramaddress,number)                      ' pasm alternative to code below, much faster

PRI SpinHubToDisplay(hubaddress,number)|i
   RAM.CogCmd("V",hubaddress,0,number)                      ' pasm version of code below

 ' ***********************************************************
 
'' DISPLAY SETTINGS
DAT
   VDP        long  479
   HDP        long  799
   HT         long  928
   HPS        long  46
   LPS        long  15
   VT         long  525
   VPS        long  16
   FPS        long  8
   HPW        long  48
   VPW        long  16

PRI Start_SSD1963
    DisplayEnable                                       ' enable one or both displays
    LCD_Reset_High
    pause1ms(5)
    LCD_Reset_Low
    pause1ms(5)
    LCD_Reset_High
    LCD_CS_High
    LCD_WR_High
    pause1ms(5)
    Lcd_Write_Com ($00E2)                             ' //PLL multiplier, set PLL clock to 120M
    Lcd_Write_Data($0023)                             ' //N=0x36 for 6.5M, 0x23 for 10M crystal ' $21??
    Lcd_Write_Data($0002)                             '
    Lcd_Write_Data($0054)                             ' dummy byte?
    Lcd_Write_Com ($00E0)                             ' // PLL enable
    Lcd_Write_Data($0001)                             ' set pll             '
    pause1ms(1)                                      '
    Lcd_Write_Com ($00E0)                             ' pll                         '
    Lcd_Write_Data($0003)                             ' lock
    pause1ms(5)
    Lcd_Write_Com ($0001)                             ' // software reset
    pause1ms(5)
    Lcd_Write_Com ($00E6)                             ' //PLL setting for PCLK, depends on resolution
    Lcd_Write_Data($0003)                             '
    Lcd_Write_Data($00ff)                             '
    Lcd_Write_Data($00ff)                             '
    Lcd_Write_Com ($00B0)                              ' //LCD SPECIFICATION
    Lcd_Write_Data($0000)                             '
    Lcd_Write_Data($0000)                             '
    Lcd_Write_Data((HDP>>8)&$00FF)                    ' //Set HDP 'hps??
    Lcd_Write_Data(HDP&$00FF)
    Lcd_Write_Data((VDP>>8)&$00FF)                    ' //Set VDP 'vps??
    Lcd_Write_Data(VDP&$00FF)
    Lcd_Write_Data($0000)
    Lcd_Write_Com ($00B4)                             ' //HSYNC
    Lcd_Write_Data((HT>>8)&$00FF)                     ' //Set HT
    Lcd_Write_Data(HT&$00FF)
    Lcd_Write_Data((HPS>>8)&$00FF)                    ' //Set HPS
    Lcd_Write_Data(HPS&$00FF)
    Lcd_Write_Data(HPW)                               ' //Set HPW
    Lcd_Write_Data((LPS>>8)&$00FF)                    ' //Set HPS
    Lcd_Write_Data(LPS&$00FF)                         '
    Lcd_Write_Data($0000)                             '
    Lcd_Write_Com ($00B6)                             ' //VSYNC
    Lcd_Write_Data((VT>>8)&$00FF)                     ' //Set VT
    Lcd_Write_Data(VT&$00FF)
    Lcd_Write_Data((VPS>>8)&$00FF)                    ' //Set VPS
    Lcd_Write_Data(VPS&$00FF)
    Lcd_Write_Data(VPW)                               ' //Set VPW
    Lcd_Write_Data((FPS>>8)&$00FF)                    ' //Set FPS
    Lcd_Write_Data(FPS&$00FF)                         '
    Lcd_Write_Com ($00BA)                             '
    Lcd_Write_Data($0005)                             ' //GPIO[3:0] out 1
    Lcd_Write_Com ($00B8)                             '
    Lcd_Write_Data($0007)                             ' //GPIO3=input, GPIO[2:0]=output
    Lcd_Write_Data($0001)                             ' //GPIO0 normal
    Lcd_Write_Com ($0036)                              ' //rotation
    Lcd_Write_Data($0021)                              ' 3 is 180
    Lcd_Write_Com ($00F0)                             ' //pixel data interface
    Lcd_Write_Data($0003)                             ' 16 bit / 565
    pause1ms(5)
    Lcd_Write_Com ($0029)                              ' //display on
    Lcd_Write_Com ($00d0)                              ' //dynamic backlight
    Lcd_Write_Data($000d)
    Lcd_Write_Com($002c)
    LCD_RS_High


PRI Displaycmd(c,d) ' instruction in one method
    Lcd_Write_Com(c) ' send out a word
    Lcd_Write_Data(d)

PRI Lcd_Write_Com(LCDlong)
    LCD_RS_low                               ' can do rs first then cs - better for latch board
    LCD_CS_Low                               ' not needed for the ILI9325 but the SSD1289 needs this
    LCD_Writ_Bus(LCDlong)
    LCD_CS_High                              ' not needed for the ILI9325 but the SSD1289 needs this
 
PRI Lcd_Write_Data(LCDlong)
    LCD_RS_High                              ' can do rs first then cs
    LCD_CS_Low                               ' not needed for the ILI9325 but the SSD1289 needs this  
    LCD_Writ_Bus(LCDlong)
    LCD_CS_High                              ' not needed for the ILI9325 but the SSD1289 needs this

PRI Lcd_Write_Fast_Data(LCDlong)            ' write RS elsewhere then skip the RS above as this is a latch output and takes longer
    LCD_CS_Low                               ' not needed for the ILI9325 but the SSD1289 needs this  
    LCD_Writ_Bus(LCDlong)
    LCD_CS_High                              ' not needed for the ILI9325 but the SSD1289 needs this 

PRI LCD_Writ_Bus(LCDLong)
    'LCDLong &= %00000000_00000000_11111111_11111111    ' mask to a word. Not needed if care taken always to send a word value
    OUTA &= %11111111_11111111_00000000_00000000        ' set P0-P15 to zero ready to OR
    OUTA |= LCDLong                                     ' merge with the word to output
    LCD_WR_Low                                          ' send out the data
    LCD_WR_High

PRI LCD_WR_Low
   OUTA &= %11111111_11111011_11111111_11111111         ' p18 low

PRI LCD_WR_High
   OUTA |= %00000000_00000100_00000000_00000000         ' p18 high

PRI LCD_CS_Low
   OUTA &= %11111111_11110111_11111111_11111111         ' p19 low    

PRI LCD_CS_High                                         
   OUTA |= %00000000_00001000_00000000_00000000         ' p19 high  

PRI LCD_RESET_Low                                       ' reset low
   RAM.Latch_ResetLow

PRI LCD_RESET_High
   RAM.Latch_ResetHigh

PRI LCD_RS_Low                                          ' for historical reasons this subroutine calls another
   RAM.Latch_RS_Low

PRI LCD_RS_High
   RAM.Latch_RS_High      








 
{
'' SSD1289
PUB Draw(x1, y1, x2, y2)                                ' sets the pixel to x1,y1 and then fills the next (x2-x1)*(y2-y1) pixels
    DisplayEnable                                       ' enable one or both displays
    ifnot orientation                                   ' landscape mode so swap x and y
      result :=x1                                       ' swap x1 and y1
      x1 := y1
      y1 := result
      result := x2                                      ' swap x2 and y2
      x2 :=y2
      y2 := result
    Displaycmd($0044,(x2<<8)+x1)
    Displaycmd($0045,y1)
    Displaycmd($0046,y2)
    Displaycmd($004e,x1)
    Displaycmd($004f,y1)
    Lcd_Write_Com($0022)
    LCD_RS_High                                       ' after sending out commands, set RS high via latch
}
{
PRI Start_SSD1289                                       ' based on C driver
    DisplayEnable                                       ' enable one or both displays
    LCD_Reset_High
    pause1ms(5)
    LCD_Reset_Low
    pause1ms(10)
    LCD_Reset_High
    LCD_CS_High
    LCD_WR_High
    pause1ms(20)
' based on C code
    Displaycmd($0000,$0001)  'Turn Oscillator on                                POR-$0000
    Displaycmd($0003,$A8A4)  'Power control (1)                                 POR-$6664
    Displaycmd($000C,$0000)  'Power control (2)                                 POR- ?
    Displaycmd($000D,$080C)  'Power control (3)                                 POR-$0009
    Displaycmd($000E,$2B00)  'Power control (4)                                 POR-$3200
    Displaycmd($001E,$00B0)  'Power control (5)                                 POR-$0029
    Displaycmd($0001,$2B3F)  'Driver output control,    *landscape?? $6B3F*     POR-$433F
    Displaycmd($0002,$0600)  'LCD drive AC control                              POR-$0400
    Displaycmd($0010,$0000)  'Sleep Mode                sleep mode off          POR-$0001
    Displaycmd($0011,$6070)  'Entry Mode,               *landscape? $4030*      POR-$6830
    Displaycmd($0005,$0000)  'Compare Register (1)                              POR-$0000
    Displaycmd($0006,$0000)  'Compare Register (2)                              POR-$0000
    Displaycmd($0016,$EF1C)  'Horizontal Porch                                  POR-$EFC1
    Displaycmd($0017,$0003)  'Vertical Porch                                    POR-$0003
    Displaycmd($0007,$0233)  'Display Control                                   POR-$0000
    Displaycmd($000B,$0000)  'Frame cycle Control                               POR-$D308
    Displaycmd($000F,$0000)  'Gate Scan start position                          POR-$0000
    Displaycmd($0041,$0000)  'Vertical Scroll Control (1)                       POR-$0000
    Displaycmd($0042,$0000)  'Vertical Scroll Control (2)                       POR-$0000
    Displaycmd($0048,$0000)  'First Window Start                                POR-$0000
    Displaycmd($0049,$013F)  'First Window End                                  POR-$013F
    Displaycmd($004A,$0000)  'Second Window Start                               POR-$0000
    Displaycmd($004B,$0000)  'Second Window End                                 POR-$013F
    Displaycmd($0044,$EF00)  'Horizontal Ram Address Postion                    POR-$EF00
    Displaycmd($0045,$0000)  'Vertical Ram Address Start                        POR-$0000
    Displaycmd($0046,$013F)  'Vertical Ram Address End                          POR-$013F
    Displaycmd($0030,$0707)
    Displaycmd($0031,$0204)
    Displaycmd($0032,$0204)
    Displaycmd($0033,$0502)
    Displaycmd($0034,$0507)
    Displaycmd($0035,$0204)
    Displaycmd($0036,$0204)
    Displaycmd($0037,$0502)
    Displaycmd($003A,$0302)
    Displaycmd($003B,$0302)
    Displaycmd($0023,$0000)   'RAM write data mask (1)                           POR-$0000
    Displaycmd($0024,$0000)   'RAM write data mask (2)                           POR-$0000
    Displaycmd($0025,$8000)   'not in datasheet?
    Displaycmd($004f,$0000)   'RAM Y address counter                             POR-$0000
    Displaycmd($004e,$0000)   'RAM X address counter                             POR-$0000
    Lcd_Write_Com($0022)
}